Attribute VB_Name = "mMain"
Option Explicit

Public Const S_OK = 0&                                'Return value for theme functions

Public Type tagInitCommonControlsEx
   lngSize As Long
   lngICC As Long
End Type

Public Declare Function InitCommonControlsEx Lib "COMCTL32.DLL" (iccex As tagInitCommonControlsEx) As Boolean
Public Const ICC_USEREX_CLASSES = &H200

'Misc.
Private Const HWND_DESKTOP = 0
Private Const LOGPIXELSX = 88    '  Logical pixels/inch in X
Private Const LOGPIXELSY = 90    '  Logical pixels/inch in Y

Public Is2000OrAbove As Boolean
Public bGlobalUseParentFormhDC As Boolean
Public IsVista As Boolean
Public b120DPI As Boolean

Private Declare Function GetVersion Lib "kernel32" () As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
'

Private Sub Main()

   Dim msgString As String
   Dim m_OsVersion As WINVERINFO
   Dim lMajor As Long
   Dim lMinor As Long
   Dim lRevision As Long
   Dim lBuildNumber As Long
   Dim iccex As tagInitCommonControlsEx
      
   m_OsVersion = OsVersion
      
   If Not IsThemed() Then
   
      If m_OsVersion.lMajor = 5 And m_OsVersion.lMinor < 1 Then 'W2K
   
         msgString = "You are running XpControls on Windows 2000." & vbCrLf & vbCrLf
         
      ElseIf m_OsVersion.lMajor = 5 And m_OsVersion.lMinor > 0 Then 'XP
   
         msgString = "You are running XpControls on XP with themes disabled." & vbCrLf & vbCrLf
      
      ElseIf m_OsVersion.lMajor = 6 And m_OsVersion.lMinor >= 0 Then 'Vista
      
         msgString = "You are running XpControls on Vista with themes disabled." & vbCrLf & vbCrLf
      
      End If
      
      msgString = msgString & "Please note that these controls where written specifically for Windows XP/Vista themes. " '& vbCrLf
      msgString = msgString & "The Xpcontrols will look no different from the default VB6 controls - legacy support has " '& vbCrLf
      msgString = msgString & "only been implemented for backwards compatibility." & vbCrLf & vbCrLf
      
      If (m_OsVersion.lMajor >= 5 And m_OsVersion.lMinor > 0) Or (m_OsVersion.lMajor = 6 And m_OsVersion.lMinor >= 0) Then 'XP/Vista
   
          msgString = msgString & "To see the XpControls full potential, please enable themes." & vbCrLf
         
      End If
      
      If (m_OsVersion.lMajor = 5 And m_OsVersion.lMinor < 1) Then 'W2K
   
         msgString = msgString & "Please run this demo on an XP/Vista computer with themes enabled." & vbCrLf
         
      End If
         
      MsgBox msgString, vbInformation, "XpControls"
      
   End If
   
   'Code by vbAccelerator.com
   
   ' we need to call InitCommonControls before we
   ' can use XP visual styles.  Here I'm using
   ' InitCommonControlsEx, which is the extended
   ' version provided in v4.72 upwards (you need
   ' v6.00 or higher to get XP styles)
   On Error Resume Next
   ' this will fail if Comctl not available
   '  - unlikely now though!
   
   With iccex
       .lngSize = LenB(iccex)
       .lngICC = ICC_USEREX_CLASSES
   End With
   InitCommonControlsEx iccex
   
   ' now start the application
   On Error GoTo 0
   
   MainForm.Show
   
End Sub

Public Sub GetWindowsVersion( _
      Optional ByRef lMajor = 0, _
      Optional ByRef lMinor = 0, _
      Optional ByRef lRevision = 0, _
      Optional ByRef lBuildNumber = 0, _
      Optional ByRef bIsNt = False _
   )
   Dim lR As Long
   Dim hDC As Long
   Dim XPIXELSPERINCH As Long
   Dim YPIXELSPERINCH As Long
   Dim retVal As Long

   lR = GetVersion()
   lBuildNumber = (lR And &H7F000000) \ &H1000000
   If (lR And &H80000000) Then lBuildNumber = lBuildNumber Or &H80
   lRevision = (lR And &HFF0000) \ &H10000
   lMinor = (lR And &HFF00&) \ &H100
   lMajor = (lR And &HFF)
   bIsNt = ((lR And &H80000000) = 0)
   
   If lMajor = 6 Then
      IsVista = True
   Else
      IsVista = False
   End If
   
   hDC = 0
   hDC = GetDC(HWND_DESKTOP)
     
   If hDC <> 0 Then
       XPIXELSPERINCH = GetDeviceCaps(hDC, LOGPIXELSX)
       YPIXELSPERINCH = GetDeviceCaps(hDC, LOGPIXELSY)
       retVal = ReleaseDC(0, hDC)
   End If
   
   If XPIXELSPERINCH = 120 Then
      b120DPI = True
   ElseIf XPIXELSPERINCH > 96 And XPIXELSPERINCH < 120 Then
      MsgBox "Using non standard DPI settings i.e. > 96 and < 120, will probably" & vbCrLf & "give undesirable results."
      b120DPI = False
   Else
      b120DPI = False
   End If
   
End Sub

Public Function OsVersion() As WINVERINFO

   Dim lMajor As Long
   Dim lMinor As Long
   Dim lRevision As Long
   Dim lBuildNumber As Long
   Dim tWINVERINFO As WINVERINFO
   
   GetWindowsVersion lMajor, lMinor, lRevision, lBuildNumber

   With tWINVERINFO
      .lMajor = lMajor
      .lMinor = lMinor
      .lRevision = lRevision
      .lBuildNumber = lBuildNumber
   End With
   
   If tWINVERINFO.lMajor >= 5 Then
      Is2000OrAbove = True
   End If
   
   OsVersion = tWINVERINFO
   
End Function

